<template>
  <q-card class="PopUpCard AddPollCard">
      
    <h5>Add Poll</h5>

    <q-separator class="breaker"></q-separator>

    <q-form ref="formRef" @submit="handleCreatePoll" @reset="handleResetForm">
    
        <q-input
        :label="$t('create_poll.title')"
        :rules="[(val) => (val && val.length > 0) || $t('create_poll.title')]"
        filled
        v-model="Poll.Title"/>

        <ol id="options" style="padding-left :0px;">
            <li v-for="(item, index) in Poll.Options" :key="item.message" style="width: 100%; display: block">
                <q-input
                :label="$t('create_poll.option_placeholder', [index + 1])"
                :rules="[(val) => (val && val.length > 0) || $t('create_poll.option_placeholder', [index + 1])]"
                filled
                v-model="item.Text" style="display: inline-block; width: 90%;"/>
                
                <q-btn v-if="index > 1" flat 
                    color="red-4" 
                    icon="delete_forever"
                    @click="delOption(index)" 
                    style="display: inline-block; width: 10%;" />
            </li>
        </ol>

        <div style="width: 100%; text-align: center;">
            <q-btn flat color="primary" :disable="Poll.Options.length >= 6" icon="add" style="display: inline-block; width: 15%;" @click="addOption"/>
        </div>
        
        <div class="row items-center justify-between">
            <q-checkbox
                v-model="Poll.IsAnon"
                :label="$t('create_poll.anonymous')"
                class="q-my-md" />
            <q-space />
            <q-btn
                type="submit"
                color="primary"
                rounded
                icon-right="poll" >
                    {{$t('create_poll.create')}}&nbsp;
            </q-btn>
        </div>
    </q-form>

  </q-card>
</template>
<script>

export default {
  props: {
    addPoll: {
      required: true
    },
  },
  data() {
    return {
        Poll : {
            Title : "",
            IsAnon: false,
            Options : [{Text: ""},{Text: ""}]
        }
    };
  },
  methods: {
    addOption() 
    {
        this.Poll.Options.push({"Text":""})
    },
    delOption(index) 
    {
        this.Poll.Options.splice(index, 1);
    },
    handleCreatePoll()
    {
        this.addPoll(this.Poll);
        this.$refs.formRef.reset();
    },
    handleResetForm() {
        this.Poll =  {
            Title : "",
            IsAnon: false,
            Options : [{Text: ""},{Text: ""}]
        }
    },
  }
};
</script>
<style scoped>
    .AddPollCard {
        padding: 15px;
    }
    .AddPollCard h5{
        margin: 10px 0px 10px 0px;
    }
    .breaker {
        margin-bottom: 10px;
    }
</style>